classification
Title: undefined behavior and crashes in case of a bad sys.modules
Type: crash Stage: resolved
Components: Interpreter Core Versions: Python 3.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: eric.snow Nosy List: Oren Milman, brett.cannon, eric.snow, ncoghlan, serhiy.storchaka
Priority: normal Keywords: patch

Created on 2017-09-09 17:36 by Oren Milman, last changed 2017-09-15 22:51 by eric.snow. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 3565 merged eric.snow, 2017-09-14 06:23
PR 3606 open eric.snow, 2017-09-15 22:51
Messages (7)
msg301783 - (view) Author: Oren Milman (Oren Milman) * Date: 2017-09-09 17:36
at least on my Windows, the following code:

import sys
sys.modules = []


- when run interactively, causes weird behavior, e.g. exit() doesn't exit the
  interpreter, and print() doesn't print.
  then, pressing Ctrl+C causes 'Assertion failed: !PyErr_Occurred(), file ..\Objects\call.c, line 803'

- when run as a script, causes PyImport_Cleanup() to raise a negative ref count
  Fatal Python error.

  (this is because PyImport_Cleanup() (in Python/import.c) assumes that
  PyImport_GetModuleDict() returned a dict.)


IIUC, this bug was introduced in https://github.com/python/cpython/pull/1638
(which resolved #28411).
msg301926 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2017-09-11 23:20
I'm looking into this.
msg301936 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2017-09-12 02:47
This is pretty messy. :(  Ideally we would disallow setting sys.modules to anything except a dict (or perhaps any mapping).  However, we don't have that option currently (see https://github.com/ericsnowcurrently/cpython/tree/sys-module).  In the meantime we have to fix up all the places that are expecting a mapping.

Part of the problem here is that a number of places fail silently, as evidenced by the failures Oren pointed out...
msg301949 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2017-09-12 11:18
I haven't finished reviewing PR 1638. I'm not sure that this change is worth. It breaks a code that assumes that sys.module is a dict, and I afraid it slows down importing. Maybe revert this change until resolving all problems?
msg302001 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2017-09-12 22:54
> I haven't finished reviewing PR 1638. I'm not sure that this change
> is worth. It breaks a code that assumes that sys.module is a dict,
> and I afraid it slows down importing. Maybe revert this change until
> resolving all problems?

Yeah, I'm leaning that way myself.  I'll take another look later today or tomorrow.  FWIW, the likelihood of this causing problems to actual users is extremely low, so the urgency to fix this isn't high.  Still, I don't want this to linger.

As I said before, ideally we would prevent non-mappings from getting assigned to sys.modules.  One alternative would be to introduce sys.__modules__ and fall back to it if sys.modules is invalid.
msg302027 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2017-09-13 01:55
Introducing sys.__modules__ doesn't solve the problem, since you'd be able to recreate the problems Oren reports just by messing with that as well as with sys.modules.

And we try reasonable hard to protect users from completely breaking the interpreter just by assigning nonsense to sys module attributes.

So my recommendation would be to revert #28411, and make it clearer that the purpose of the interpreter state attribute is to defend against nonsensical rebinding of sys.modules, and that it can't be removed unless/until the sys module is switched to a custom type that enforces type checks on some of its attributes.
msg302147 - (view) Author: Eric Snow (eric.snow) * (Python committer) Date: 2017-09-14 06:46
New changeset 93c92f7d1dbb6e7e472f1d0444c6968858113de2 by Eric Snow in branch 'master':
bpo-31404: Revert "remove modules from Py_InterpreterState (#1638)" (#3565)
https://github.com/python/cpython/commit/93c92f7d1dbb6e7e472f1d0444c6968858113de2
History
Date User Action Args
2017-09-15 22:51:14eric.snowsetpull_requests: + pull_request3597
2017-09-15 22:50:59eric.snowsetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2017-09-14 06:46:06eric.snowsetmessages: + msg302147
2017-09-14 06:23:47eric.snowsetkeywords: + patch
stage: patch review
pull_requests: + pull_request3554
2017-09-13 01:55:24ncoghlansetmessages: + msg302027
2017-09-12 22:54:23eric.snowsetnosy: + brett.cannon, ncoghlan
messages: + msg302001
2017-09-12 11:18:22serhiy.storchakasetmessages: + msg301949
2017-09-12 02:47:28eric.snowsetmessages: + msg301936
2017-09-11 23:20:51eric.snowsetassignee: eric.snow
messages: + msg301926
2017-09-09 19:24:37serhiy.storchakasetnosy: + eric.snow, serhiy.storchaka
2017-09-09 17:36:25Oren Milmancreate